//internal low level functions
//this is for 
//parport related functions
#include <asm/io.h>
#include <unistd.h>
#include "ppmc.h"

extern unsigned int ppmc_base_addr;
/*
	base+0		data
 *	base+1		status
 *	base+2		control
  *	base+3		EPP address
 *	base+4		EPP data
*/
#define SPPDATA ppmc_base_addr
#define STATUSPORT ppmc_base_addr+1
#define CONTROLPORT ppmc_base_addr+2
#define ADDRPORT ppmc_base_addr+3
#define DATAPORT ppmc_base_addr+4

void BusReset(void)
{
  outb(0,CONTROLPORT);
  outb(4,CONTROLPORT);
}

//internal routine to initialize the port itself
short InitializeParPort(void);
//internal routine to initialize the encoder board(s)

 int ClrTimeout(void)
{
	unsigned char r;

	if  (!(inb(STATUSPORT) & 0x01))
		return 0;

	/* To clear timeout some chips require double read */
	
	BusReset;
	r = inb(STATUSPORT);
	outb(r | 0x01, STATUSPORT); /* Some reset by writing 1 */
	r = inb(STATUSPORT);

	return !(r & 0x01);
}


void SelAddr(unsigned int port)
{
  /* writes a device address to the data port and toggles address strobe low, and waits
                for handshake */
    ClrTimeout();
    //    outb(inb(CONTROLPORT) & 0xDF,CONTROLPORT);  // set port direction to output
    outb(0x04,CONTROLPORT);  // set port direction to output
 
   outb(port,ADDRPORT);
    return;
}

void WriteData(unsigned char byte)
{
  /* writes data to the data port and toggles data strobe low, and waits
                for handshake */
    outb(byte,DATAPORT);
	ClrTimeout();
    return;
}
void WriteData16(unsigned short word)
{
  
    outb(word & 0x00FF,DATAPORT);
    outb(word >> 8,DATAPORT);
    return;
}
unsigned short ReadData(void)
  {
    //    outb(inb(CONTROLPORT) | 0x20,CONTROLPORT);  // set port direction to input
    outb(0x24,CONTROLPORT);  // set port direction to input
    return inb(DATAPORT);
    
  }

unsigned short SelRead(unsigned int port)
{
  /* writes a device address to the data port and toggles address strobe low, and waits
                for handshake, then inputs data byte and toggles data strobe low, then
                high again */
    ClrTimeout();
    outb(inb(CONTROLPORT) & 0xDF,CONTROLPORT);  // set port direction to output
    outb(port,ADDRPORT);
    outb(inb(CONTROLPORT) | 0x20,CONTROLPORT);  // set port direction to input
    return inb(DATAPORT);
    
}

void SelWrt(unsigned int port, unsigned char byte)
{
  /* writes a device address to the data port and toggles address strobe low, and waits
                for handshake, then outputs data byte and toggles data strobe low, then
                high again */
    ClrTimeout();
    //    outb(inb(CONTROLPORT) & 0xDF,CONTROLPORT);  // set port direction to output
    outb(0x04,CONTROLPORT);  // set port direction to output
    outb(port,ADDRPORT);
    outb(byte,DATAPORT);
    return;
}
void SelWrt16(unsigned int port, unsigned short word)
{
  /* writes a device address to the data port and toggles address strobe low, and waits
                for handshake, then (outputs data byte and toggles data strobe low, then
                high again) repeat for 2nd byte */
    ClrTimeout();
    outb(inb(CONTROLPORT) & 0xDF,CONTROLPORT);  // set port direction to output
    outb(port,ADDRPORT);
    outb(word & 0x00FF,DATAPORT);
    outb(word >> 8,DATAPORT);
    return;
}


short int InitializeParPort(void)
{
#ifdef LINUX
	ioperm(ppmc_base_addr,5,1) ;//turn on the 5
			//if you want to run ecp, need to use iopl()
#endif
  return 0;
}

int ppmcMotInit(const char * stuffstuff)
{
	if(InitializeParPort()==-1)
		return -1;
	BusReset;
	if(EncoderInit()==-1)
		return -1;
	/*	if(DACInit()==-1)
		return -1;
	if(DIOInit()==-1)
	return -1;  */
  return 0;

}

int ppmcMotQuit()
{
	DACQuit();
	EncoderQuit();
	DIOQuit();
  return 0;
}



